#!/bin/bash

set -e

usage ()
{
    echo
    echo "Usage: makekeys.sh plainfile keyprefix numkeys numenoughkeys"
    echo
    echo "Example: makekeys.sh plain key_ 10 7"
    echo
    exit 1
}

if ! [ $# = 4 ]; then
    usage;
fi

plainfile="$1"
keyprefix="$2"
numkeys="$3"
numenoughkeys="$4"

rm -f $keyprefix*

echo Randomized splitting of your key into $numenoughkeys keys.
./randsplit "$plainfile" "$keyprefix" "$numenoughkeys"

kl=""
i=0
while [ $((i<numkeys)) = 1 ]; do
    kl="$kl $keyprefix$i"
    i=$((i+1))
done

echo Building redundant additional $((numkeys-numenoughkeys)) keys.
./redun $kl

echo all done. you now have the keyfiles
echo $kl
echo You only need $numenoughkeys of those files to reconstruct your file \""$plainfile"\"

echo
exit 0
