#include <stdio.h>
#include <errno.h>
#include <string>
#include <strstream>

void fatal(const string &x)
{
  fprintf(stderr,"\n\nFatal error:\n%s\n\n",x.c_str());
  exit(1);
};

void fatalerrno(const string &x)
{
  fprintf(stderr,"\n\nFatal error:\n%s\n\nErrno = %s\n\n",x.c_str(),strerror(errno));
  exit(1);
};

int main(int argc, char *argv[])
{
  if (argc!=4) fatal("randsplit infile outfileprefix numoutfiles\nexample: randsplit secret base 10");
  
  FILE *in=fopen(argv[1],"rb");
  if (in==0) fatalerrno("cannot open infile");
  
  FILE *rnd=fopen("/dev/urandom","rb");
  if (rnd==0) fatalerrno("cannot open /dev/urandom");
  
  FILE *out[256];
  int numout=atol(argv[3]);
  if (numout<1) fatal("numoutfiles must be at least 1");
  for (int a=0;a<numout;++a) {
    string name(argv[2]);
    strstream s;
    s<<a;
    name+=s.str();
    out[a]=fopen(name.c_str(),"wb");
    if (out[a]==0) fatalerrno("cannot open one of the outfiles");
  };
  
  for (;;) {
    unsigned char v;
    if (fread(&v,1,1,in)!=1) break;

    for (int a=1;a<numout;++a) {
      unsigned char r;
      fread(&r,1,1,rnd);
      v^=r;
      fwrite(&r,1,1,out[a]);
    };
    
    fwrite(&v,1,1,out[0]);
  };
  

  for (int a=0;a<numout;++a) fclose(out[a]);
  
  fclose(rnd);
  fclose(in);
  
  return 0;
};
