#!/bin/bash

set -e

usage ()
{
    echo
    echo "Usage: unlockdoor.sh keyprefix outputsecret numenoughkeys"
    echo
    echo "Example: unlockdoor.sh key_ mysecret 7"
    echo
    exit 1
}

if ! [ $# = 3 ]; then
    usage;
fi


keyprefix="$1"
outputsecret="$2"
numkeyfiles=$(ls -l1 $keyprefix* | wc -l)
numkeyfiles=$(echo $numkeyfiles)
numenoughkeys="$3"

echo "i found $numkeyfiles keyfiles."
if [ $((numkeyfiles < numenoughkeys)) = 1 ]; then
    echo Thats not enough. sorry.
    exit 1
else
    echo Thats enough keyfiles. proceeding...
fi

numkeys=0
for name in $keyprefix*; do
    x=$(echo $name | sed "s/^$keyprefix//g")
    if [ $((x>numkeys)) = 1 ]; then
	numkeys=$x
    fi
done
numkeys=$((numkeys+1))

kl=""
i=0
while [ $((i<numkeys)) = 1 ]; do
    kl="$kl $keyprefix$i"
    i=$((i+1))
done

echo Now rebuilding the eventually missing keys.
./redun $kl

echo Now reuniting the keys to get the secret file.
./randjoin "$keyprefix" "$outputsecret" "$numenoughkeys"

echo all done. you now have the secret file \""$outputsecret"\"

echo
exit 0
